#include <systemc.h>
#include "case4.sc"

 sc_clock m_clock("m_clock", 10, 0.5, 0, false);
 sc_signal<bool> p_reset;
 sc_signal<bool >  display;
 sc_signal<sc_uint<8> > LED, sw;

 static int clck=0;
 case4 case4("case4");

SC_MODULE (ctrl) {
  sc_in<bool> m_clock;
void res() {
  clck++;
  if(display.read()) display = 0;
  if((random() & 3)==3) display = 1;
  if(clck > 2) p_reset = 0;
  else p_reset = 1;
  sw.write(random() & 255);
  printf("%3d: display: %1x  SW: %02X  LED: %02X\n", clck, (int)display.read(), (int)sw.read(), (int)LED.read());
}

SC_CTOR (ctrl) {
	SC_METHOD(res);
	sensitive << m_clock.neg(); 
}
};


int sc_main(int argc,  char *argv[])
{
 FILE *fp;
 int i;
 sc_trace_file* tf = sc_create_vcd_trace_file("case4");
 sc_trace(tf,case4.m_clock,"case4.m_clock");
 sc_trace(tf,case4.p_reset,"case4.p_reset");
 sc_trace(tf,case4.display,"case4.display");
 sc_trace(tf,case4.sw,"case4.sw");
 sc_trace(tf,case4.LED,"case4.LED");


 ctrl ct("ct");

 ct.m_clock(m_clock);

 case4.m_clock(m_clock);
 case4.p_reset(p_reset);
 case4.display(display);
 case4.sw(sw);
 case4.LED(LED);

 sc_start(1000, SC_NS);
 sc_close_vcd_trace_file(tf);
}
