#include <systemc.h>

#include "case5.sc"

 sc_clock m_clock("m_clock", 10, 0.5, 0, false);
 sc_signal<bool> p_reset;
 sc_signal<bool >  memrd, memwt, start;
 sc_signal<sc_uint<8> > address, dataout, datain;
 int  ram[256];
 static int clck=0;
 case5 cpu("cpu");

SC_MODULE (ctrl) {
  sc_in<bool> m_clock;
void envrn() {
  clck++;
  if(clck == 0) p_reset = 0;
  if(p_reset.read()) p_reset = 0;
  if(clck == 3) p_reset = 1;

  if(start.read()) start = 0;
  if(clck == 5) start = 1;

  printf("\n%3d: PC: %02X  OP: %02X  OPR: %02X  ACC: %02X", clck, (int)cpu.pc.read(), (int)cpu.op.read(), (int)cpu.opr.read(), (int)cpu.acc.read());
  if(memrd.read()) {
        printf("\tA: %02X  R: %02X", (int)address.read(), ram[(int)address.read()]);
	datain = (sc_uint<8>)ram[(int)address.read()];
        }
  if(memwt.read()) {
        printf("\tA: %02X  W: %02X", (int)address.read(), (int)dataout.read());
	ram[(int)address.read()] = dataout.read();
        }
}

SC_CTOR (ctrl) {
	SC_METHOD(envrn);
	sensitive << m_clock.neg(); 
}
};


int sc_main(int argc,  char *argv[])
{
 FILE *fp;
 int i;
 sc_trace_file* tf = sc_create_vcd_trace_file("case5");
 sc_trace(tf,cpu.m_clock,"cpu.m_clock");
 sc_trace(tf,cpu.p_reset,"cpu.p_reset");
 sc_trace(tf,cpu.start,"cpu.start");
 sc_trace(tf,cpu.address,"cpu.address");
 sc_trace(tf,cpu.datain,"cpu.datain");
 sc_trace(tf,cpu.dataout,"cpu.dataout");
 sc_trace(tf,cpu.memrd,"cpu.memrd");
 sc_trace(tf,cpu.memwt,"cpu.memwt");
 sc_trace(tf,cpu.pc,"cpu.pc");
 sc_trace(tf,cpu.acc,"cpu.acc");
 sc_trace(tf,cpu.op,"cpu.op");
 sc_trace(tf,cpu.opr,"cpu.opr");
 sc_trace(tf,cpu.ifetch,"cpu.ifetch");
 sc_trace(tf,cpu.decode,"cpu.decode");
 sc_trace(tf,cpu.exec,"cpu.exec");

 if(!(fp = fopen("case5.mem","r"))) {fprintf(stderr, "Open error\n"); sc_stop();}
 for(i=0;i<256;i++) {
  if(fscanf(fp,"%x", &ram[i]) ==EOF) break;
 }

 ctrl ct("ct");

 ct.m_clock(m_clock);

 cpu.m_clock(m_clock);
 cpu.p_reset(p_reset);
 cpu.address(address);
 cpu.dataout(dataout);
 cpu.datain(datain);
 cpu.start(start);
 cpu.memrd(memrd);
 cpu.memwt(memwt);

 sc_start(1000, SC_NS);
 sc_close_vcd_trace_file(tf);
}
